summaryrefslogtreecommitdiffstats
path: root/package
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-10-26 02:09:30 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-10-26 02:09:30 +0000
commitcea208a5bbe67affba22ea40853822b8a1e493e5 (patch)
tree0535f33113ea1201db6af9bfeaddec22377ac758 /package
parent11f6a780e57e9febfa701f688575dfc79cc1f970 (diff)
add cf2nand script for copying a cf card installation to nand flash automatically on rb532
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@5300 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package')
-rwxr-xr-xpackage/base-files/rb532-2.6/sbin/cf2nand61
1 files changed, 61 insertions, 0 deletions
diff --git a/package/base-files/rb532-2.6/sbin/cf2nand b/package/base-files/rb532-2.6/sbin/cf2nand
new file mode 100755
index 000000000..eb1a0bec1
--- /dev/null
+++ b/package/base-files/rb532-2.6/sbin/cf2nand
@@ -0,0 +1,61 @@
+#!/bin/sh
+. /etc/functions.sh
+
+copy_kernel() {
+ local input="$1"
+ local output="$2"
+ local cmdline="$3"
+ size="$(echo -n "$cmdline" | wc -c)"
+ dd if="$input" bs=3M count=1 | (
+ dd bs=4112 count=1
+ echo -n "$cmdline"
+ dd if=/dev/zero bs="$((512 - $size))" count=1
+ dd bs=512 count=1 of=/dev/null
+ cat
+ ) > "$output"
+}
+
+fstype="$(mount | grep ' / ' | awk '{print $5}')"
+[ -d /tmp/cf2nand ] && {
+ echo "/tmp/cf2nand already exists"
+ exit 1
+}
+
+mkdir /tmp/cf2nand
+mkdir /tmp/cf2nand/rootfs
+mount -t "$fstype" /dev/root /tmp/cf2nand/rootfs || {
+ echo "Mounting rootfs failed."
+ exit 1
+}
+
+boot="$(find_mtd_part 'RouterBoard NAND Boot')"
+main="$(find_mtd_part 'RouterBoard NAND Main')"
+[ -z "$boot" -o -z "$main" ] && {
+ echo "Cannot find NAND Flash partitions"
+ exit 1
+}
+
+echo "Erasing filesystem..."
+mtd erase Boot 2>/dev/null >/dev/null
+mtd erase Main 2>/dev/null >/dev/null
+
+mkdir /tmp/cf2nand/p1
+mkdir /tmp/cf2nand/p2
+mount -t yaffs2 "$boot" /tmp/cf2nand/p1
+mount -t yaffs2 "$main" /tmp/cf2nand/p2
+
+echo "Copying kernel..."
+copy_kernel /dev/cf/card0/part1 /tmp/cf2nand/p1/kernel "root=/dev/mtdblock1 rootfstype=yaffs2 " 2>/dev/null >/dev/null
+umount /tmp/cf2nand/p1
+rmdir /tmp/cf2nand/p1
+
+echo "Copying filesystem..."
+( cd /tmp/cf2nand/rootfs; tar c . ) | ( cd /tmp/cf2nand/p2; tar x )
+sync
+umount /tmp/cf2nand/p2
+rmdir /tmp/cf2nand/p2
+
+umount /tmp/cf2nand/rootfs
+rmdir /tmp/cf2nand/rootfs
+rmdir /tmp/cf2nand
+